**************************
*  This routine presents a list of questions concerning the structure of
*  a database that is to be build. The list of fields is presented to the
*  right of the question area. This list is presented so that when the question
*  is asked concerning the index you can remember what fields have been defined.
*  This list is not a scrolling list so you may want to change that portion of
*  it. The program then asked for the name of the file form which to fill the
*  database. The file should be a standard text unformatted file. MicroStar saves
*  such a file. The program looks for a character return chr(13) and a line feed
*  chr(26) and knows that is the end of the line and starts to read the next
*  line. Each line repersents a field in the current record. I hope you find the
*  program helpful in your database programming.
**************************


/* BUILD A DATABASE ROUTINE */

#INCLUDE "box.ch"

DO WHILE .T.

   SETCOLOR("R+G/N,G+/R")

   CLEAR SCREEN

   @0,0 SAY PADC( " CREATE AND FILL A DATABASE ROUTINE FROM TEXT FILE ",80," ")
   catname:=SPACE(10)
   cattype:=" "
   catsize:=0
   catdecimal:=0

   buildfrom:=SPACE(12)
   dbf_array:={}
   dbf_size:=0
   data_name:=space(8)
   index_name:=space(8)
   yes:="Y"
   read_byte:=""
   read_by:=" "
   good_str:=" "

   @4,5 say "Database Name          :" get Data_name pict "!!!!!!!!"
   READ

/* INPUT DBF FIELDS DESIRED AND ADD TO A DATABASE ARRAY TO BUILD .DBF FILE */

   SETCOLOR("G/N")
   @5,4,10,40 BOX B_DOUBLE
   SETCOLOR("R+G/N,G+/R")
   DO WHILE catname==SPACE(10)
      dbf_size:=dbf_size+1
      @6,5 say "Database Field Name    :" get catname pict "@A!"
      @7,5 say "Database Type          :" get cattype pict "!"
      @8,5 say "Database Field Size    :" get catsize pict "99"
      @9,5 say "database Field Decimal :" get catdecimal pict "9"
      READ
      If catname==SPACE(10)
         EXIT
      ENDIF
      catname:=ALLTRIM(catname)
      AADD(dbf_array,{CATNAME,CATTYPE,CATSIZE,CATDECIMAL})
      @5,42 SAY "NAME     TYPE SIZE DECIMAL"
      @5+dbf_size,42 say ALLTRIM(catname)
      @5+dbf_size,52 say ALLTRIM(cattype)
      @5+dbf_size,57 say ALLTRIM(STR(catsize))
      @5+dbf_size,64 say ALLTRIM(STR(catdecimal))
      catname:=SPACE(10)
      cattype:=" "
      catsize:=0
      catdecimal:=0
      LOOP
   ENDDO
   dbf_size:=dbf_size-1

   @12,5 say "Index on :" get index_name pict "!!!!!!!!"
   READ


/* CREATE  THE DATABASE FROM THE NAME FIELD AND THE DBF_ARRAY */

   DBCREATE(data_name,dbf_array)
   USE &data_name

/* INPUT FILE FROM WHICH TO FILL THE DATABASE */

   @24,0 say "Be sure to add extention!"
   @12,5 say "Name of File to fill database from :" get buildfrom pict "@!"
   READ
   @24,0 say "                         "

/* OPEN ORGIN FILE AND FILL DATABSE FROM IT */

   set color to "r+g*/n"
   @24,0 say "Filling database please wait...."

   buildfrom:=ALLTRIM(buildfrom)
   file_hand1:=FOPEN(buildfrom,0)

   DO WHILE read_by#CHR(26)

      APPEND BLANK
      FOR I=1 to dbf_size
         field_name:=dbf_array[I]
         catagory:=field_name[1]
         DO WHILE read_byte#chr(10)
            good_str:=FREAD(file_hand1,@read_by,1)
            IF read_by==chr(10).OR.read_by==chr(26)
               EXIT
            ELSE
                read_byte:=read_byte+read_by
            ENDIF
         ENDDO
      IF read_by==chr(26)
         EXIT
      ENDIF
      read_byte:=SUBSTR(read_byte,1,LEN(read_byte)-1)

      REPLACE &data_name->&catagory WITH read_byte
      read_byte:=""
      NEXT

   ENDDO

   DELETE
   PACK
   INDEX ON &Index_name to &Data_name

/* CHECK TO SEE IF ANOTHER NEEDS TO BUILT */

   @24,0 SAY PADC(" ",80," ")
   @4,0 CLEAR TO 23,79
   setcolor("g+/n")
   @24,15 SAY " Finished! Do you wish to fill another ? Y/N :" get yes pict "Y"
   READ
   @24,0 SAY PADC(" ",80," ")
   IF yes=="N"
      SETCOLOR("W/N")
      clear screen
      EXIT
   ENDIF

ENDDO

